



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>bzoj 4514: 数字配对</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">bzoj 4514: 数字配对</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 11:42:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>题目大意</h2>
<p><a href="http://www.lydsy.com/JudgeOnline/problem.php?id=4514" rel="external nofollow noreferrer">自己看</a></p>
<h2>题解</h2>
<p>我们打表观察规律发现一定能构成一张二分图<br /><br />
也就是不存在奇环<br /><br />
所以我们一般保证费用非负的最大流即可.</p>
<pre class="prettyprint linenums"><code>#include &lt;cstdio&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;algorithm&gt;<br />
using namespace std;<br />
typedef long long ll;<br />
template&lt;typename T&gt;inline void read(T &amp;x){<br />
	x=0;char ch;bool flag = false;<br />
	while(ch=getchar(),ch&lt;'!');if(ch == '-') ch=getchar(),flag = true;<br />
	while(x=10*x+ch-'0',ch=getchar(),ch&gt;'!');if(flag) x=-x;<br />
}<br />
inline int cat_max(const int &amp;a,const int &amp;b){return a&gt;b ? a:b;}<br />
inline int cat_min(const int &amp;a,const int &amp;b){return a&lt;b ? a:b;}<br />
const int maxn = 256;<br />
const int inf = 0x3f3f3f3f;<br />
inline bool judge(int n){<br />
	if(n == 1) return false;<br />
	if(n == 2) return true;<br />
	for(int i = 2;i*i&lt;=n;++i){<br />
		if(n % i == 0) return false;<br />
	}return true;<br />
}<br />
int a[maxn],b[maxn];ll c[maxn];<br />
namespace gra{<br />
	struct Edge{<br />
		int to,next;<br />
	}G[21010];<br />
	int head[maxn],cnt;<br />
	void add(int u,int v){<br />
		//printf(&quot;%d\n&quot;,cnt);<br />
		G[++cnt].to = v;<br />
		G[cnt].next = head[u];<br />
		head[u] = cnt;<br />
	}<br />
	inline void insert(int u,int v){<br />
		add(u,v);add(v,u);<br />
	}<br />
	int col[maxn];<br />
#define v G[i].to<br />
	void dfs(int u,int c){<br />
		col[u] = c;<br />
		for(int i = head[u];i;i=G[i].next){<br />
			if(col[v] == -1) dfs(v,c^1);<br />
		}<br />
	}<br />
#undef v<br />
}<br />
namespace net{<br />
	struct Edge{<br />
		int to,next,cap;<br />
		ll cost;<br />
	}G[21010];<br />
	int head[maxn],cnt=1;<br />
	void add(int u,int v,int c,ll co){<br />
		//printf(&quot;%d\n&quot;,cnt);<br />
		G[++cnt].to = v;<br />
		G[cnt].next = head[u];<br />
		head[u] = cnt;<br />
		G[cnt].cap = c;<br />
		G[cnt].cost = co;<br />
	}<br />
	inline void insert(int u,int v,int c,ll co){<br />
		//printf(&quot;%d -&gt; %d (%d,%lld)\n&quot;,u,v,c,co);<br />
		add(u,v,c,co);add(v,u,0,-co);<br />
	}<br />
	const int lim = maxn&lt;&lt;2;<br />
	int S = maxn-5,T = S+1,l,r,q[lim+10];<br />
	int flow[maxn],p[maxn];<br />
	ll dis[maxn],nw_dis;<br />
	int ans;<br />
	bool inq[maxn];<br />
	inline int find(int r,ll w){<br />
		int l = 0,ret = 0;<br />
		while(l &lt;= r){<br />
			int mid = l+r &gt;&gt; 1;<br />
			if(mid*w+nw_dis &gt;= 0) ret = mid,l = mid+1;<br />
			else r = mid-1;<br />
		}return ret;<br />
	}<br />
#define v G[i].to<br />
	bool spfa(){<br />
		memset(dis,-0x3f,sizeof dis);<br />
		l = 0;r = -1;q[++r] = S;<br />
		dis[S] = 0;flow[S] = inf;<br />
		inq[S] = true;<br />
		while(l &lt;= r){<br />
			int u = q[l % lim];++l;<br />
			for(int i = head[u];i;i=G[i].next){<br />
				if(dis[v] &lt; dis[u] + G[i].cost &amp;&amp; G[i].cap){<br />
					dis[v] = dis[u] + G[i].cost;<br />
					flow[v] = min(flow[u],G[i].cap);<br />
					p[v] = i;<br />
					if(!inq[v]){<br />
						q[++r % lim] = v;<br />
						inq[v] = true;<br />
					}<br />
				}<br />
			}inq[u] = false;<br />
		}if(dis[T] == dis[0]) return false;<br />
		if(dis[T] &lt; 0) flow[T] = find(flow[T],dis[T]);<br />
		if(flow[T] == 0) return false;<br />
		ans += flow[T];<br />
		nw_dis += flow[T]*dis[T];<br />
		for(int u = T;u != S;u = G[p[u]^1].to)<br />
			G[p[u]].cap -= flow[T],G[p[u]^1].cap += flow[T];<br />
		return true;<br />
	}<br />
#undef v<br />
}<br />
int main(){<br />
	int n;read(n);memset(gra::col,-1,sizeof gra::col);<br />
	for(int i=1;i&lt;=n;++i) read(a[i]);<br />
	for(int i=1;i&lt;=n;++i) read(b[i]);<br />
	for(int i=1;i&lt;=n;++i) read(c[i]);<br />
	for(int i=1;i&lt;=n;++i){<br />
		for(int j=1;j&lt;=n;++j){<br />
			if(i == j) continue;<br />
			if(a[i] % a[j] == 0 &amp;&amp; judge(a[i]/a[j])){<br />
				gra::insert(i,j);<br />
			}<br />
		}<br />
	}<br />
	for(int i=1;i&lt;=n;++i) if(gra::col[i] == -1) gra::dfs(i,0);<br />
	for(int u=1;u&lt;=n;++u){<br />
		if(gra::col[u] == 0){<br />
			net::insert(net::S,u,b[u],0);<br />
			for(int i = gra::head[u];i;i=gra::G[i].next){<br />
				net::insert(u,gra::G[i].to,inf,c[u]*c[gra::G[i].to]);<br />
			}<br />
		}else{<br />
			net::insert(u,net::T,b[u],0);<br />
		}<br />
	}while(net::spfa());<br />
	printf(&quot;%d\n&quot;,net::ans);<br />
	getchar();getchar();<br />
	return 0;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zllo3q.html">Spring学习之AOP总结帖</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq13mj68.html">hibernate date类型插入数据库时精度只到日期没有时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ep5wx9.html">json&plus;mvc</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyddp0jq.html">提升WordPress站点速度的八个建议</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vpvpo8.html">Oracle使用&percnt;rowtype变量存储一行数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w172wq.html">实用的透明背景mark图标</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn7rxe8.html">在C51中如何实现软复位？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z0gk29.html">window&period;opener方法的使用 js跨域</a>
		</li>
						<li><a href="https://www.batexi.com/a/8memmgrq.html">javascript中处理引号编码&amp;amp&semi;&num;034&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppkm39.html">hdu 4876 ZCC loves cards&lpar;暴力&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eypr0e9.html">PDM：Training Models of Shape from Sets of Examples</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jpkp0q.html">配置正确情况下，hadoop 没有namenode的一个解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j152w09.html">C语言强化&mdash;&mdash;排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllgyy0q.html">andorid       帧布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kojym5q.html">Chrome多线程下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp46n09.html">mysql时间格式化函数日期格式h和H区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn5w0jq.html">AR&period;Drone 2&period;0四轴飞机体验：最好的玩具航拍器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvgdzdq.html">RHEL6解决无法使用YUM源问题（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx24rlz8.html">xpack文件打包解包代码库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkzdg18.html">C&num; Winform程序CPU占用高的原因和解决方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvdxxgyq.html">MP4文件格式的解析，以及MP4文件的分割算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwo674r9.html">python sax解析xml</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r4jd548.html">【selenium&plus;Python unittest】之发送带中文附件的邮箱</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zv5o639.html">Process Stats&colon;了解你的APP怎样使用内存</a>
			</li>
						<li><a href="https://www.batexi.com/a/q15gk209.html">Unity3D研究院编辑器之脚本设置ToolBar及脚本设置顶视图</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zv5kk19.html">【BZOJ4238】电压 DFS树</a>
			</li>
						<li><a href="https://www.batexi.com/a/90dw2jm8.html">EasyPlayerPro Windows播放器本地快照抓拍截图功能实现方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlozo10q.html">九度OJ 1013：开门人和关门人 （排序）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93j0j2g8.html">php调用短网址接口</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jeyplg8.html">&lbrack;容易&rsqb;在O&lpar;1&rpar;时间复杂度删除链表节点</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
